--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

if wdwMod_Info == nil then wdwMod_Info = {} end 
if wdwMod_Rotations == nil then wdwMod_Rotations = {} end

local bloodCharges, expiresBP, expiresFF, refreshDisease, posDisease = 0, 0, 0, 0, 0

-- Following locals are for the routine used in "Setup". Yes, for Frost DKs I am aware that Blood runes are now Death runes
local bloodR, unholyR, frostR, deathR = 0, 0, 0, 0
local runes = { [1] = function() bloodR=bloodR+1 end, [2] = function() unholyR=unholyR+1 end,
		[3] = function() frostR=frostR+1 end, [4] = function() deathR=deathR+1 end, }
local runeCDs = {0,0,0,0,0,0,}

local function AddToQueue(spellItemID, direction, expires, pos)

	-- Will insert a spell/item at the first available location, starting from the left-most position consistent with any remaining CD/expiry

	-- spellItemID	:		the spell/item to queue
	-- direction	:		Direction to look for space in the queue. Optional. +1 is the default. -1 will cause a seek leftwards
	-- expires	:		the remaining CD or time to expiry (optional). If nil then calculates

	-- return codes:	0  = no space
	--			n  = queue location

	direction = direction or 1
	if direction ~= 1 then direction = -1 end

	if pos == 0 then return 0 end

	if not pos then
		local cdLeft = expires or WeDontWipe:CooldownLeft(spellItemID)
		pos = math.floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if pos < 1 then pos = 1 end
		if pos > wdw_maxQueueLength then return 0 end
	end

	local savedPos = pos
	while wdw_Queue[pos] ~= 0 do
		pos = pos + direction
		if pos > wdw_maxQueueLength then return 0 end
		if pos == 0 then
			pos = savedPos
			direction = 1
		end
	end

	wdw_Queue[pos] = spellItemID
	return pos
end

--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

wdwMod_Info["Taraezor@Thaurissan DKFrost"] = {

	["Class"] = "Deathknight",
	["Specialisation"] = "Frost",
	["Version"] = "1.01 for Patch 5.4",
	["Author"] = "Taraezor@Thaurissan",
	["Template"] = "1.00",
--	["Sound"] = "Sound/Doodad/Fx_Owl05.ogg", -- Owl sfx. Quiet and inoffensive
	["Sound"] = "Sound/Spells/Shaysbell.ogg",

	["Interrupt"] = { 47476,58,47528,57},		-- Strangulate, Mind Freeze

	["Cooldown"] = {47568,76,46584,56,42650,80,61999,72},
	-- Empower Rune Weapon, Raise Dead, Army of the Dead, Raise Ally
}

wdwMod_Rotations["Taraezor@Thaurissan DKFrost"] = {

	["Rotations"] = {

		["DW"] = {

			["Buffs"] = {"FrostPres",},
			["Rotation"] = {"Setup","SR35","PoF","FSDW","Diseases","D&D","HBDW1","OblitDW1","HBFF","OblitDW2","HBDW3","HoW","FinaliseDW",},
		},

		["2H"] = {

			["Buffs"] = {"FrostPres",},
			["Rotation"] = {"Setup","SR35","PoF","Diseases","Obliterates2H","FS2H1","HBFF","FS2H2","Oblit2H3","HoW","Finalise2H"},
			["Notes"] = "Raise dead should be macroed with your Pillar of Frost",
		},

	},

-- levelling: Very low health rotation: If RP>=96: Lichborne, Death Coil (-40 RP), Icebound Fortitude (+12 RP), Death Coil (-40 RP), Death Strike (+12 RP), Death Coil (-40 RP)
-- or even with minion Death Pact if has talent

	["FrostPres"] = function () -- Frost Presence. Level 55

		if WeDontWipe:HasCanShow(48266) then if not wdw_buffsPlayer["48266"] then AddToQueue(48266) end end

	end,

	["Setup"] = function () -- Frost Presence. Level 55

		deathR, frostR, unholyR = 0, 0, 0
		for i=1,6 do
			if GetRuneCount(i) > 0 then
				runes[GetRuneType(i)]()
				runeCDs[i] = 0
			else
				local s,d,_ = GetRuneCooldown(i)
				runeCDs[i] = d - GetTime() + s - wdw_GCD
				-- Note: might not have a rune at this exact time but the CD might be finished before the GCD
			end
		end

		bloodCharges = 0
		if WeDontWipe:HasCanShow(45529) then -- Blood Tap
			if wdw_buffsPlayer["114851"] then -- Blood Charges
				bloodCharges = wdw_buffsPlayer["114851"].count
			end
		end

		expiresBP, expiresFF = 0, 0
		if wdw_debuffsTarget["55078"] then
			expiresBP = wdw_debuffsTarget["55078"].expires -- Blood Plague
		end
		if wdw_debuffsTarget["55095"] then
			expiresFF = wdw_debuffsTarget["55095"].expires -- Frost Fever
		end
		refreshDisease = expiresFF
		if expiresBP <= expiresFF then refreshDisease = expiresBP end
		posDisease = math.floor(( refreshDisease - wdw_GCD) / wdw_GCDtop) + 1
	end,

	["SR35"] = function () -- Soul Reaper. Level 87

		-- Tier 15 Set Bonus ups the remaining health to 45%.
		local remainingHealth = 0.35
		if wdw_buffsPlayer["138347"] then -- God was this spell ID even correct? All I could find in the Wowhead DB :(
			remainingHealth = 0.45
		end

		if WeDontWipe:HasCanShow(130735) and wdw_hasTarget then
			local health, pos = wdw_healthTarget / wdw_healthTargetMax, AddToQueue(130735)
			if (pos > 0) and (pos <= wdw_maxQueueLength) then
				if health > ((pos - 1) * 0.04 + remainingHealth) then
					wdw_Queue[pos] = 0
					return
				end
				if (deathR+frostR) == 0 then
					if bloodCharges >= 5 then
						wdw_Queue[pos] = 45529 -- Blood Tap
						if pos < wdw_maxQueueLength then wdw_Queue[pos + 1] = 130735 end -- Soul Reaper
						bloodCharges = bloodCharges - 5
					end
				end
			end
		end
	end,

	["PoF"] = function () -- Pillar of Frost. Level 68

		-- Strength boost for 20s on a 60s CD. This rotation will not displace a manual disease refresh

		if WeDontWipe:HasCanShow(51271) then -- Pillar of Frost
			local pos = AddToQueue(51271)
			if (pos > 0) and ((deathR+frostR) == 0) then
				if bloodCharges >= 5 then
					if pos == 1 then
						wdw_Queue[1] = 45529 -- Blood Tap
						AddToQueue(51271,1,nil,2)
					else
						wdw_Queue[pos] = 0
						local posBT = AddToQueue(45529,-1,0)
						if posBT >= pos then
							AddToQueue(51271,1,nil,pos)
						else
							wdw_Queue[pos] = 51271
						end
					end
					bloodCharges = bloodCharges - 5
				end
			end
		end
	end,

	["HBFF"] = function () -- Howling Blast. Level 55

		if WeDontWipe:HasCanShow(49184) then -- Howling Blast
			if wdw_buffsPlayer["59052"] then -- Freezing Fog buff from a Rime (59057) proc (level 70)
				AddToQueue(49184) -- Howling Blast - free!
			end
		end
	end,

	["HoW"] = function () -- Horn of Winter. Level 65

		if WeDontWipe:HasCanShow(57330) then -- Horn of Winter
			AddToQueue(57330)
		end
	end,

	["Diseases"] = function () -- Diseases

		-- Frost Fever and Blood Plague must stay up all the time. FF will mostly be automatically up due to Howling Blast/Rime

		local pos, ready = 0, 0

		-- Plague Leech. Level 56. Tier 1 talent. Consumes BOTH diseases to generate up to 2 x fully-depleted runes

		if WeDontWipe:HasCanShow(123693) then -- Plague Leech. Level 56. Tier 1 talent. Use a.s.a.p.
			ready = WeDontWipe:CooldownLeft(123693)
			if (ready < refreshDisease) and (refreshDisease > 0) and ((frostR == 0) or (unholyR == 0)) then
				AddToQueue(123693,1,ready)
				refreshDisease, expiresFF, expiresBP = ready, ready, ready
				
			end
		end
		
		-- Clipped or not with Plague Leech, must now refresh diseases. Mostly this will be Blood Plague here
		-- Outbreak is the best here if off CD
		if WeDontWipe:HasCanShow(77575) then -- Outbreak. Level 81
			ready = WeDontWipe:CooldownLeft(77575)
			if ready <= refreshDisease then
				AddToQueue(77575,1,refreshDisease)
				return
			end
		end

		-- Now try Unholy Blight. Level 56. Tier 1 talent
		if WeDontWipe:HasCanShow(115989) then -- Unholy Blight
			ready = WeDontWipe:CooldownLeft(115989)
			if ready <= refreshDisease then
				AddToQueue(115989,1,refreshDisease)
				return
			end
		end

		-- So must handle both diseases individually. As well, anything we use will cost us in runes

		if WeDontWipe:HasCanShow(45462) then -- Plague Strike whenever Blood Plague is about to expire
			pos = AddToQueue(45462,1,expiresBP)
			if (pos == 1) and GetInventoryItemID(INVSLOT_OFFHAND) and (unholyR == 0) then
				pos = 0 -- i.e. for Dual Wield, don't update if no Unholy runes as don't want to use a Death rune
			end
			if (pos > 0) and ((deathR+unholyR) == 0) then
				if (pos == 1) then
					if (runeCDs[1] > 0) and (runeCDs[2] > 0) and (runeCDs[3] > 0) and (runeCDs[4] > 0) then -- and no runes ready
						if bloodCharges >= 5 then
							wdw_Queue[1] = 45529 -- Blood Tap
							bloodCharges = bloodCharges - 5
						else
							wdw_Queue[1] = 6603 -- Auto Attack
						end
						AddToQueue(45462,1,nil,2)
					end
				elseif (runeCDs[1] > wdw_GCDtop * (pos -1)) and (runeCDs[2] > wdw_GCDtop * (pos -1)) and
						(runeCDs[5] > wdw_GCDtop * (pos -1)) and (runeCDs[6] > wdw_GCDtop * (pos -1)) then -- and no runes ready in time
					if bloodCharges >= 5 then
						local posBT = AddToQueue(45529) -- Blood Tap
						if posBT > pos then
							wdw_Queue[posBT] = 0 -- i.e. a BT after the PS is pretty useless but still show the PS anyway
						else
							bloodCharges = bloodCharges - 5
						end
					end
				end
			end
		end

		-- realise that we are not thoroughly calculating actual runes at each position etc. Would be messy for how much gain?

		if WeDontWipe:HasCanShow(49184) then -- Howling Blast whenever Frost Fever is about to expire
			pos = AddToQueue(49184,1,expiresFF)
			if (pos > 0) and ((deathR+frostR) == 0) and not wdw_buffsPlayer["59052"] then -- and no Freezing Fog buff (granting a free Howling Blast)
				if (pos == 1) then
					if (runeCDs[1] > 0) and (runeCDs[2] > 0) and (runeCDs[5] > 0) and (runeCDs[6] > 0) then -- and no runes ready
						if bloodCharges >= 5 then
							wdw_Queue[1] = 45529 -- Blood Tap
							bloodCharges = bloodCharges - 5
						else
							wdw_Queue[1] = 6603 -- Auto Attack
						end
						AddToQueue(49184,1,nil,2)
					end
				elseif (runeCDs[1] > wdw_GCDtop * (pos -1)) and (runeCDs[2] > wdw_GCDtop * (pos -1)) and
						(runeCDs[5] > wdw_GCDtop * (pos -1)) and (runeCDs[6] > wdw_GCDtop * (pos -1)) then -- and no runes ready in time
					if bloodCharges >= 5 then
						if AddToQueue(45529,-1,nil,pos-1) > 0 then
							local posBT = AddToQueue(45529) -- Blood Tap
							if posBT > pos then
								wdw_Queue[posBT] = 0
							else
								bloodCharges = bloodCharges - 5
							end
						end
					end
				end
			end
		end
	end,

	["FSDW"] = function () -- Frost Strike. Level 55

		-- Frost Strike if runic power about to be capped. Otherwise if killing machine proc

		if WeDontWipe:HasCanShow(45902) then -- Frost Strike
			if wdw_power > 88 then -- Runic Power
				AddToQueue(45902)
			elseif wdw_buffsPlayer["51124"] then -- Killing Machine proc
				local pos = AddToQueue(45902) -- FS
				local power = wdw_power
				for i=1,(pos-1) do
					if wdw_Queue[i] == 130735 or wdw_Queue[i] == 51271 then -- SR or PoF
						power = power + 12
					end
				end
				if power >= 25 then return end -- Only approximate as gaps not yet filled in

				-- Need a Horn of Winter to save the day
				if WeDontWipe:HasCanShow(57330) then -- HoW
					if (wdw_hasGlyph["104047"] and (power >= 3)) or (power >= 13) then -- Glyph of Loud Horn (extra 10 RP)
						local posHoW = AddToQueue(57330)
						if posHoW > pos then
							wdw_Queue[posHoW] = 0
							return
						end
					end
				end
			end
		end
	end,

	["D&D"] = function () -- Death and Decay. Level 76

		if WeDontWipe:HasCanShow(43265) then
			local pos = AddToQueue(43265)

			if (pos == 1) and (unholyR == 2) and wdw_hasTalent["14"] then -- Runic Empowerment - avoid regenerating an Unholy Rune
				wdw_Queue[pos] = 0
				return
			end
		end
	end,

	["HBDW1"] = function () -- Howling Blast. Level 55

		if WeDontWipe:HasCanShow(49184) then -- Howling Blast
			if (deathR == 2) or (frostR == 2) then
				AddToQueue(49184) -- Howling Blast
			end
		end
	end,

	["OblitDW1"] = function () -- Obliterate. Level 58

		if WeDontWipe:HasCanShow(49020) and (unholyR == 2) and wdw_buffsPlayer["51124"] then -- Obliterate & Killing Machine buff
			local pos = AddToQueue(49020)
			if pos > posDisease then -- one or both diseases has expired
				wdw_Queue[pos] = 0
				return
			end

			if ((deathR+frostR) == 0) then
				if bloodCharges >= 5 then
					local posBT = AddToQueue(45529)
					if (posBT > 0) and (posBT < pos) then -- Blood Tap					
						bloodCharges = bloodCharges - 5
					else
						wdw_Queue[pos] = 0
						wdw_Queue[posBT] = 0
					end
				end
			end
		end
	end,

	["OblitDW2"] = function () -- Obliterate. Level 58

		if WeDontWipe:HasCanShow(49020) and (unholyR == 1) then -- Obliterate
			local pos = AddToQueue(49020)
			if pos > posDisease then -- one or both diseases has expired
				wdw_Queue[pos] = 0
				return
			end

			if ((deathR+frostR) == 0) then
				if bloodCharges >= 5 then
					local posBT = AddToQueue(45529)
					if (posBT > 0) and (posBT < pos) then -- Blood Tap					
						bloodCharges = bloodCharges - 5
					else
						wdw_Queue[pos] = 0
						wdw_Queue[posBT] = 0
					end
				end
			end
		end
	end,

	["HBDW3"] = function () -- Howling Blast. Level 55

		if WeDontWipe:HasCanShow(49184) then -- Howling Blast
			local pos = AddToQueue(49184)
			if (pos > 0) and ((deathR+frostR) == 0) then
				if bloodCharges >= 5 then
					local posBT = AddToQueue(45529)
					if (posBT > 0) and (posBT < pos) then -- Blood Tap					
						bloodCharges = bloodCharges - 5
					else
						wdw_Queue[pos] = 0
						wdw_Queue[posBT] = 0
					end
				end
			end
		end
	end,

	["FinaliseDW"] = function () -- Fillers

		local hornOW, deathND, empowerRW, raiseDead, obliterate = false, false, false, false, false

		for i=1,wdw_maxQueueLength do
			if wdw_Queue[i] == 0 then
				while true do
					if bloodCharges >= 9 then -- let's not pedantically limit burning this to the cap limit of 12
						if (deathR == 0) or (frostR == 0) or (unholyR == 0) then
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							break
						end
					end
					if WeDontWipe:HasCanShow(45902) and WeDontWipe:CooldownLeft(45902) < wdw_GCD then -- Frost Strike
						if (i == 1) and (wdw_power < 20) then
							-- Need a Horn of Winter to save the day
							if WeDontWipe:HasCanShow(57330) and not hornOW then
								if (wdw_power >= 8) or (wdw_hasGlyph["104047"]) then -- Glyph of Loud Horn (extra RP)
									if WeDontWipe:CooldownLeft(57330) < wdw_GCDsum then
										wdw_Queue[i], hornOW = 57330, true
										AddToQueue(45902)
										break
									end
								end
							end
						else
							wdw_Queue[i] = 45902 -- Frost Strike
							break
						end
					end
					if not obliterate then
						if (((deathR+frostR) > 0) and unholyR > 0) or (((deathR+unholyR) > 0) and frostR > 0) then
							wdw_Queue[i], obliterate = 49020, true -- Obliterate
							break
						end
					end
					if WeDontWipe:HasCanShow(43265) and not deathND then -- Death and Decay. Don't cause Unholys to be depleted
						if unholyR == 2 then
							if WeDontWipe:CooldownLeft(43265) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], deathND = 43265, true
								break
							end
						end
					end
					if (wdw_power < 80) then -- lets not pedantically test for < 70 RP and no runes at all.
						 if WeDontWipe:HasCanShow(47568) and not empowerRW then -- Empower Rune Weapon
							if WeDontWipe:CooldownLeft(47568) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], empowerRW = 47568, true
								break
							end
						end
					end
					if WeDontWipe:HasCanShow(46584) and not raiseDead then -- Raise Dead
						if WeDontWipe:CooldownLeft(46584) < (wdw_GCD + wdw_GCDtop * (i -1)) then
							wdw_Queue[i], raiseDead = 46584, true
							break
						end
					end
					if bloodCharges >= 5 then -- Not much interested in getting Unholy runes
						if (deathR == 0) or (frostR == 0) then
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							break
						end
					end

					-- Desperate times now to fill in the gaps

					if WeDontWipe:HasCanShow(43265) and not deathND then -- Death and Decay
						if (deathR+unholyR) > 0 then
							if WeDontWipe:CooldownLeft(43265) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], deathND = 43265, true
								break
							end
						elseif bloodCharges >= 5 then -- Not much interested in getting Unholy runes
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							AddToQueue(43265)
							deathND = true
							break
						end
					end

					wdw_Queue[i] = 6603 -- Auto Attack
					break
				end
			end
		end
	end,

	["Obliterates2H"] = function () -- Obliterate. Level 58

		local pos = 0
		if WeDontWipe:HasCanShow(49020) then -- Obliterate
			if wdw_buffsPlayer["51124"] then -- Killing Machine buff
				pos = AddToQueue(49020)
				if (((deathR+frostR) > 0) and unholyR > 0) or (((deathR+unholyR) > 0) and frostR > 0) then
				elseif pos > 0 then
					if bloodCharges >= 5 then
						wdw_Queue[pos] = 45529
						if AddToQueue(49020) > 0 then bloodCharges = bloodCharges - 5 end
					end
				end
			end
			if ((deathR == 2) or (frostR == 2) or (unholyR == 2)) then
				pos = AddToQueue(49020)
				if (((deathR+frostR) > 0) and unholyR > 0) or (((deathR+unholyR) > 0) and frostR > 0) then
				elseif pos > 0 then
					if bloodCharges >= 5 then
						wdw_Queue[pos] = 45529
						if AddToQueue(49020) > 0 then bloodCharges = bloodCharges - 5 end
					end
				end
			end
		end
	end,

	["FS2H1"] = function () -- Frost Strike. Level 55. 25 RP

		if WeDontWipe:HasCanShow(45902) and (wdw_power >= 88) then -- Frost Strike
			AddToQueue(45902)
		end
	end,

	["FS2H2"] = function () -- Frost Strike. Level 55. 25 RP

		if WeDontWipe:HasCanShow(45902) then -- Frost Strike
			if (AddToQueue(45902) == 1) and (wdw_power < 20) then
				-- Need a Horn of Winter to save the day
				if WeDontWipe:HasCanShow(57330) then
					if wdw_hasGlyph["104047"] or (wdw_power >= 8) then -- Glyph of Loud Horn - extra +10 RP
						if WeDontWipe:CooldownLeft(57330) < wdw_GCDsum then
							wdw_Queue[1] = 57330
							AddToQueue(45902)
						else
							wdw_Queue[1] = 0
						end
					else
						wdw_Queue[1] = 0
					end
				end
			end
		end
	end,

	["Oblit2H3"] = function () -- Obliterate. Level 58

		if WeDontWipe:HasCanShow(49020) then -- Obliterate
			local pos = AddToQueue(49020)
			if (((deathR+frostR) > 0) and unholyR > 0) or (((deathR+unholyR) > 0) and frostR > 0) then
			elseif pos > 0 then
				if bloodCharges >= 5 then
					local posBT = AddToQueue(45529)
					if (posBT > 0) and (posBT < pos) then -- Blood Tap					
						bloodCharges = bloodCharges - 5
					else
						wdw_Queue[pos] = 0
						wdw_Queue[posBT] = 0
					end

				else
					wdw_Queue[pos] = 0
				end
			end
		end
	end,

	["Finalise2H"] = function () -- Fillers

		local hornOW, deathND, empowerRW, raiseDead, obliterate = false, false, false, false, false

		for i=1,wdw_maxQueueLength do
			if wdw_Queue[i] == 0 then
				while true do
					if bloodCharges >= 9 then -- let's not pedantically limit burning this to the cap limit of 12
						if (deathR == 0) or (frostR == 0) or (unholyR == 0) then
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							break
						end
					end
					if WeDontWipe:HasCanShow(45902) and WeDontWipe:CooldownLeft(45902) < wdw_GCD then -- Frost Strike
						if (i == 1) and (wdw_power < 20) then
							-- Need a Horn of Winter to save the day
							if WeDontWipe:HasCanShow(57330) and not hornOW then
								if (wdw_power >= 8) or (wdw_hasGlyph["104047"]) then -- Glyph of Loud Horn (extra RP)
									if WeDontWipe:CooldownLeft(57330) < wdw_GCDsum then
										wdw_Queue[i], hornOW = 57330, true
										AddToQueue(45902)
										break
									end
								end
							end
						else
							wdw_Queue[i] = 45902 -- Frost Strike
							break
						end
					end
					if not obliterate then
						if (((deathR+frostR) > 0) and unholyR > 0) or (((deathR+unholyR) > 0) and frostR > 0) then
							wdw_Queue[i], obliterate = 49020, true -- Obliterate
							break
						end
					end
					if WeDontWipe:HasCanShow(43265) and not deathND then -- Death and Decay. Don't cause Unholys to be depleted
						if unholyR == 2 then
							if WeDontWipe:CooldownLeft(43265) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], deathND = 43265, true
								break
							end
						end
					end
					if (wdw_power < 80) then -- lets not pedantically test for < 70 RP and no runes at all.
						 if WeDontWipe:HasCanShow(47568) and not empowerRW then -- Empower Rune Weapon
							if WeDontWipe:CooldownLeft(47568) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], empowerRW = 47568, true
								break
							end
						end
					end
					if WeDontWipe:HasCanShow(46584) and not raiseDead then -- Raise Dead
						if WeDontWipe:CooldownLeft(46584) < (wdw_GCD + wdw_GCDtop * (i -1)) then
							wdw_Queue[i], raiseDead = 46584, true
							break
						end
					end
					if bloodCharges >= 5 then -- Not much interested in getting Unholy runes
						if (deathR == 0) or (frostR == 0) then
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							break
						end
					end

					-- Desperate times now to fill in the gaps

					if WeDontWipe:HasCanShow(43265) and not deathND then -- Death and Decay
						if (deathR+unholyR) > 0 then
							if WeDontWipe:CooldownLeft(43265) < (wdw_GCD + wdw_GCDtop * (i -1)) then
								wdw_Queue[i], deathND = 43265, true
								break
							end
						elseif bloodCharges >= 5 then -- Not much interested in getting Unholy runes
							wdw_Queue[i] = 45529	-- Blood Tap
							bloodCharges = bloodCharges - 5
							AddToQueue(43265)
							deathND = true
							break
						end
					end

					wdw_Queue[i] = 6603 -- Auto Attack
					break
				end
			end
		end
	end,
}